题目大意:
给出一组合法的括号。
括号要么不涂颜色,要么就涂上红色或者绿色。
匹配的括号只能有一个有颜色。
两个相邻的括号不能有相同的颜色。
思路分析:
因为是一个合法的括号序列。
所以每个括号与之匹配的位置是一定的。
那么就可以将这个序列分成两个区间。 (L - match[L] ) (match[L]+1, R)
用递归先处理小区间,再转移大区间。
因为条件的限制,所以记录区间的同时,还要记录区间端点的颜色。
然后就是一个递归的过程。
#include <cstdio> #include <iostream> #include <cstring> #include <algorithm> using namespace std; typedef long long ll; const int mod = 1000000007; char str[800]; int match[800]; ll dp[800][800][3][3]; int stk[800]; int top=-1; void dfs(int l,int r) { if(l+1==r) { dp[l][r][0][1]=dp[l][r][0][2]=dp[l][r][1][0]=dp[l][r][2][0]=1; return; } if(match[l]==r) { dfs(l+1,r-1); for(int i=0;i<3;i++) for(int j=0;j<3;j++) { if(j!=1)dp[l][r][0][1]=(dp[l][r][0][1]+dp[l+1][r-1][i][j])%mod; if(j!=2)dp[l][r][0][2]=(dp[l][r][0][2]+dp[l+1][r-1][i][j])%mod; if(i!=1)dp[l][r][1][0]=(dp[l][r][1][0]+dp[l+1][r-1][i][j])%mod; if(i!=2)dp[l][r][2][0]=(dp[l][r][2][0]+dp[l+1][r-1][i][j])%mod; } } else { dfs(l,match[l]); dfs(match[l]+1,r); for(int i=0;i<3;i++)for(int j=0;j<3;j++) for(int k=0;k<3;k++)for(int p=0;p<3;p++) { if(j && j==k)continue; dp[l][r][i][p]=(dp[l][r][i][p]+(dp[l][match[l]][i][j]*dp[match[l]+1][r][k][p]%mod)%mod); } } } int main() { scanf("%s",str+1); int n=strlen(str+1); memset(match,0,sizeof match); for(int i=1;i<=n;i++) { if(str[i]=='(') stk[++top]=i; else match[stk[top--]]=i; } memset(dp,0,sizeof dp); dfs(1,n); ll ans=0; for(int i=0;i<3;i++) for(int j=0;j<3;j++) ans=ans+dp[1][n][i][j]; printf("%I64d\n",ans%mod); return 0; }
codeforces 149D - Coloring Brackets (区间dp)
时间: 2024-10-17 23:37:52